;**********************************************************************
;    Filename:	ondoset.asm 
;    Date:          	2004/6/5
;    File Version:
;**********************************************************************

	list      		p=16F648             ; list directive to define processor
	#include		 <p16F648a.inc>         ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC & _LVP_OFF

;***** VARIABLE DEFINITIONS
w_temp			EQU     0x20       	 ; variable used for context saving 
status_temp		EQU     0x21       	 ; variable used for context saving

wait_data		EQU	0x30		;wait data
taihi			EQU	0x31		;taihi data
suji_1			EQU	0x32		;suji(10)
suji_2			EQU	0x33		;suji(1)
d_count			EQU	0x34		;hyouji count data
count			EQU	0x35		;warikomi count data
ry_out			EQU	0x36		;ry out data
dip_data			EQU	0x37		;dip sw scan data
settei_data		EQU	0x38		;settei data 
set_on			EQU	0x39		;ry set on data
sokutei			EQU	0x3a		;sokutei
tenmetsu		EQU	0x3b		;settei tenmetsu
taihi_2			EQU	0x3c		;hikaku taihi

tm0_setdata		EQU	0xef		;FFH-EFH=16 16*2=32usec

;**********************************************************************
		ORG     		0x000            	 ; processor reset vector
  		goto    		main             	 ; go to beginning of program

;----------------------------------------------------------------------------------
		ORG     		0x004            	 ; interrupt vector location
		movwf   	w_temp           	 ; save off current W register contents
		movf		STATUS,w          ; move status register into W register
		movwf		status_temp     	  ; save off contents of STATUS register

		;---------------------------------	
		bcf			INTCON,T0IF
		movlw		tm0_setdata
		movwf		TMR0

		incf		count,1
		;----------------------------------
next_int
		movf    		status_temp,w    	 ; retrieve copy of STATUS register
		movwf		STATUS           	 ; restore pre-isr STATUS register contents
		swapf   		w_temp,f
		swapf  		w_temp,w        	  ; restore pre-isr W register contents
		retfie                  			  ; return from interrupt
;---------------------------------------------------------------------------------------
main
		call			port_set
		call			comp_set
		
		movlw		16h
		movwf		PORTA
		movlw		70h
		movwf		PORTB

		call			set_dcount

		call			timer0_set

		movlw		00h
		movwf		suji_1
		movwf		suji_2
		movwf		ry_out
		movwf		settei_data
		movwf		set_on
		movwf		tenmetsu
		
		movlw		090h
		movwf		sokutei
		
		goto		ondo_settei
;--------------------------------------
main_loop
		btfss		PORTA,4
		goto		ondo_settei

main_loop_2
		btfss		set_on,0
		goto		main_2
		movf		sokutei,0
		call			ondo_p1
		subwf		settei_data,0
		btfss		STATUS,0
		goto		main_3
		movlw		00h
		movwf		set_on
		movwf		ry_out		
		goto		main_3
		
main_2
		movf		sokutei,0
		subwf		settei_data,0
		btfsc		STATUS,0
		goto		main_3
		movlw		01h
		movwf		set_on
		movwf		ry_out
		goto		main_3
		
main_3
		decf		d_count,1
		btfss		STATUS,2
		goto		main_led
		call			set_dcount
		call			keisoku
		
		call			ondo_henkan
		movwf		count
		movwf		sokutei
				
		call			suji_henkan

main_led
		movf		suji_2,0
		iorlw		70h
		btfsc		ry_out,0
		iorlw		80h
		movwf		PORTB
		bcf			PORTB,5
		call			wait_1
		bsf			PORTB,5
		
		movf		suji_1,0
		iorlw		70h
		btfsc		ry_out,0
		iorlw		80h
		movwf		PORTB
		bcf			PORTB,4
		call			wait_1
		bsf			PORTB,4
		
		goto		main_loop
;---------------------------------------
ondo_settei
		movlw		00h
		movwf		dip_data
		bsf			PORTB,4
		bsf			PORTB,5
		movlw		00h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,0
		movlw		01h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,1
		movlw		02h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,2
		movlw		03h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,3
		movlw		04h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,4
		movlw		05h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,5
		movlw		06h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,6
		movlw		07h
		iorlw		70h
		movwf		PORTB
		call			wait_0
		btfsc		PORTB,6
		bsf			dip_data,7

		movf		dip_data,0
		movwf		settei_data
		andlw		0fh
		sublw		09h
		btfsc		STATUS,0
		goto		next_check
		movlw		0f0h
		andwf		settei_data,1
next_check
		swapf		settei_data,0
		andlw		0fh
		sublw		09h
		btfsc		STATUS,0
		goto		next_next		
		movlw		0fh
		andwf		settei_data,1
next_next
		movf		settei_data,0
		movwf		count
		call			suji_henkan

		incf		tenmetsu,1
		btfsc		tenmetsu,7
		goto		main_loop

		movf		suji_2,0
		iorlw		70h
		movwf		PORTB
		bcf			PORTB,5
		call			wait_1
		bsf			PORTB,5
		
		movf		suji_1,0
		iorlw		70h
		movwf		PORTB
		bcf			PORTB,4
		call			wait_1
		bsf			PORTB,4

		goto		main_loop
;-------------------------------------------------------------------------------
ondo_p1
		addlw		01h
		movwf		taihi_2
		andlw		0fh
		sublw		0ah
		btfss		STATUS,2
		goto		ondo_p1_next
		movf		taihi_2,0
		andlw		0f0h
		addlw		10h
		return

ondo_p1_next
		movf		taihi_2,0
		return
;-------------------------------------------------------------------------------
wait_0
		movlw		0fh
		movwf		wait_data
		goto		wait_2
wait_1		
		movlw		0ffh
		movwf		wait_data
wait_2
		nop
		decfsz		wait_data,1
		goto		wait_2
		return
;-------------------------------------------------------------------------------
keisoku
		movlw		00h
		movwf		count
		call			ra3_out
		bcf			PORTA,3
		nop
		call			wait_1
		call			ra3_in
		bsf			INTCON,T0IE
keisoku2
		nop
		btfsc		CMCON,7
		goto		keisoku2
		bcf			INTCON,T0IE
		return	
;------------------------------------------------------------------------------
set_dcount
		movlw		0x80
		movwf		d_count
		return
;-------------------------------------------------------------------------------
ra3_out
									;RA3(OUT)
		bsf			STATUS,RP0
		bcf			TRISA,3
		nop
		bcf			STATUS,RP0
		return
;--------------------------------------------------------------------------------
ra3_in
									;RA3(IN)
		bsf			STATUS,RP0
		bsf			TRISA,3
		nop
		bcf			STATUS,RP0
		return
;--------------------------------------------------------------------------------
suji_henkan
		movf		count,0
		andlw		0fh
		movwf		suji_2
		swapf		count,0
		andlw		0fh
		movwf		suji_1
		return
;------------------------------------------------------------------------------
ondo_henkan	
		movf		count,0
		movwf		taihi
		movlw		low(ondo_table)
		addwf		taihi,1
		movlw		high(ondo_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
ondo_table
		retlw		0ff		;00
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;10
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		000
		retlw		001
		retlw		001
		retlw		002
		retlw		003		;20
		retlw		004
		retlw		004
		retlw		005
		retlw		006
		retlw		006
		retlw		007
		retlw		008
		retlw		008
		retlw		009
		retlw		010
		retlw		010
		retlw		011
		retlw		012
		retlw		012
		retlw		013
		retlw		014		;30
		retlw		014
		retlw		015
		retlw		015
		retlw		016
		retlw		017
		retlw		017
		retlw		018
		retlw		018
		retlw		019
		retlw		019
		retlw		020
		retlw		021
		retlw		021
		retlw		022
		retlw		022
		retlw		023		;40
		retlw		024
		retlw		024
		retlw		025
		retlw		025
		retlw		026
		retlw		026
		retlw		027
		retlw		028
		retlw		028
		retlw		029
		retlw		029
		retlw		030
		retlw		030
		retlw		031
		retlw		032
		retlw		032		;50
		retlw		033
		retlw		033
		retlw		034
		retlw		035
		retlw		035
		retlw		036
		retlw		036
		retlw		037
		retlw		038
		retlw		038
		retlw		039
		retlw		040
		retlw		040
		retlw		041
		retlw		042
		retlw		042		;60
		retlw		043
		retlw		044
		retlw		044
		retlw		045
		retlw		046
		retlw		046
		retlw		047
		retlw		048
		retlw		048
		retlw		049
		retlw		050
		retlw		051
		retlw		052
		retlw		052
		retlw		053
		retlw		054		;70
		retlw		055
		retlw		056
		retlw		056
		retlw		057
		retlw		058
		retlw		059
		retlw		060
		retlw		061
		retlw		062
		retlw		063
		retlw		064
		retlw		065
		retlw		066
		retlw		067
		retlw		068
		retlw		069		;80
		retlw		070
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;90
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;A0
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;B0
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;C0
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;D0
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;E0
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff		;F0
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff
		retlw		0ff

;-------------------------------------------------------------------------------
port_set				;RA0,RA3(OUT)
					;RA1,RA2,RA4(IN)
					;RB0,RB1,RB2,RB3,RB4,RB5,RA7(OUT)
					;RB6(IN)
		bsf			STATUS,RP0
		clrf			TRISA
		bsf			TRISA,1
		nop
		bsf			TRISA,2
		nop
		bsf			TRISA,4
		nop
		clrf			TRISB
		bsf			TRISB,6
		nop
		bcf			STATUS,RP0
		return
;------------------------------------------------------------------------------
comp_set
		movlw		05h		;(00)C2OUT,C1OUT
							;(00)C2INV,C1INV
							;(0)CIS
							;(101)CM2:CM0
		movwf		CMCON
		return
;------------------------------------------------------------------------------
timer0_set

		bsf			STATUS,RP0
		movlw		080h		;(1)PORTB NOT PULLUP
								;(0)INTEDG
								;(0)TOCS
								;(0)TOSE
								;(0)PSA
								;(000)1/2
		movwf		OPTION_REG
		bcf			STATUS,RP0

		movlw		tm0_setdata
		movwf		TMR0
		bcf			INTCON,T0IE
		bsf			INTCON,GIE
		return
;-------------------------------------------------------------------------------

		end                     ; directive 'end of program'
